package com.zhentao.filter;

import com.alibaba.fastjson2.JSON;
import com.zhentao.pojo.User;
import com.zhentao.vo.Result;
import com.zhentao.utils.CacheService;
import com.zhentao.utils.JwtService;
import com.zhentao.utils.ThreadLocalUtil;
import jakarta.servlet.*;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.web.authentication.WebAuthenticationDetailsSource;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Component
public class JwtFilter implements Filter {
    @Autowired
    private CacheService cacheService;

    static ArrayList<String> list = new ArrayList<>();
    static {
        list.add("/user/yan");
        list.add("/user/login");
        list.add("/user/login1");
        list.add("/user/test");
    }

    @Override
    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
        HttpServletRequest req = (HttpServletRequest) request;
        HttpServletResponse res = (HttpServletResponse) response;
        //获取路径
        String uri = req.getRequestURI();
        System.out.println(uri);
//        if("/user/login".equals(uri)||"/user/login1".equals(uri)||"/user/yan".equals(uri)|| "/user/getOpenId".equals(uri) || req.getRequestURI().startsWith("/image")){
//            //如果路径等于则放行
//            chain.doFilter(request, response);
//            return;
//        }
        if(list.contains(req.getRequestURI())){
            chain.doFilter(req,res);
            return;
        }
        //获取token
        String token = req.getHeader("Authorization");
        //获取rides数据
        String key = "aaa" + token;
        String s = cacheService.get(key);
        System.out.println(key);
        if(s==null){
            Result result = Result.ERR("当前操作有误",null);
            res.setContentType("application/json;charset=utf-8");
            res.getWriter().write(JSON.toJSONString(result));
            return;
        }
        //解析
        Map<String, Object> map = JwtService.getClaimsMap(s);
        if(map!=null){
            Object id = map.get("id");
            ThreadLocalUtil.set(id);
            Object username = map.get("username");
            Object phone = map.get("phone");
            Object perms = map.get("perms");
            Object avatar = map.get("avatar");
            User user = new User();
            user.setId((Long) id);
            user.setUsername((String) username);
            user.setPhone((String) phone);
            user.setPerms((List<String>) perms);
            user.setAvatar((String) avatar);
            //把数据存入
            UsernamePasswordAuthenticationToken usernamePasswordAuthenticationToken = new UsernamePasswordAuthenticationToken(user,null,user.getAuthorities());
            usernamePasswordAuthenticationToken.setDetails(new WebAuthenticationDetailsSource().buildDetails(req));
            SecurityContextHolder.getContext().setAuthentication(usernamePasswordAuthenticationToken);
            chain.doFilter(request, response);
            return;
        }
        Result result = Result.ERR("当前操作有误,请重新操作",null);
        res.setContentType("application/json;charset=utf-8");
        res.getWriter().write(JSON.toJSONString(result));
        return;
    }
}
